import  java.io.*;
import  java.util.*;
import  org.w3c.dom.*;
import  org.w3c.dom.html.*;
import  org.w3c.dom.html.HTMLElement.*;
import  org.openxml.*;
import  org.openxml.io.*;
import  org.openxml.x3p.*;
import  org.openxml.util.*;
import  org.openxml.parser.*;

class TestParser1 {
    static int tab;
    
    public static void main (String args[]) throws IOException {
        //Document aDoc = new Document();
        //URL aURL = null;
        Parser parser;
        InputStream is;
        Document doc;
        Publisher pub;
                       
        is = new FileInputStream("Ex3.html");
        parser = DOMFactory.createParser( is, null, null );
        doc = parser.parseDocument();
        
        System.out.println("A Parser is constructed.\n");
        //System.out.println("URL: " + doc.getURL() + "\n");
        //System.out.println(doc.getDocumentElement().getFirstChild().getNodeName() + "\n");
        //System.out.println(doc.getDocumentElement().getFirstChild().getNodeValue() + "\n");
        
        //pub = PublisherFactory.createPublisher( new File("output.html"), StreamFormat.HTML_PRETTY );
        //pub.publish( doc );
        //pub.close();
        tab = 0;
        list( doc );
        
        pub = PublisherFactory.createPublisher( new File("output.html"), StreamFormat.HTML_PRETTY );
        pub.publish( doc );
        pub.close();      
    }
    
    static void list ( Node node ) {
        while ( node != null ) {
            //for (int i=0; i< tab; i++)
            //    System.out.print("    ");
            System.out.println( "Node name [" + node.getNodeName() + "] value [" +
                                node.getNodeValue() + "]" );
            if ( node.getNodeName().compareTo("A") == 0 || node.getNodeName().compareTo("a") == 0 ) {
                NamedNodeMap map = node.getAttributes();
                if ( map != null ) {
                    System.out.println( "Not null" );
                    System.out.println( map.getLength() );
                    String attrbname = map.item(0).getNodeName().toUpperCase();
                    String attrbvalue = map.item(0).getNodeValue();
                    System.out.println( attrbname + " " + attrbvalue );
                    if ( attrbname.compareTo("HREF") == 0 ) {
                        if ( attrbvalue.compareTo("COPYRIGHT") == 0 ) {
                            System.out.println( "In the loop" );
                            Node aclonenode = node.cloneNode(true);
                            Node attrbclone = map.item(0).cloneNode(true);
                            attrbclone.setNodeValue("http://www.npac.syr.edu/" + attrbvalue);
                            aclonenode.getAttributes().setNamedItem(attrbclone);
                            System.out.println(aclonenode.getAttributes().item(0).getNodeValue());
                            node.getParentNode().replaceChild(aclonenode, node);
                        }
                    }
                }
                else {
                    System.out.println( "Null" );
                }
            }
            //if ( node.getNodeName().compareTo("#text") == 0 )
            //    --tab;
            if ( node.hasChildNodes() ) {
                //System.out.print( "-C-" );
                tab++;
                list ( node.getFirstChild() );
            }
            //System.out.print("-S-");
            node = node.getNextSibling();
        }
        //System.out.print("-E-");
        tab--;
    }
}
